/***************************************************************************
 *   $Id: checking2html.h,v 1.5 2005/03/01 02:38:02 kenjen Exp $ *
 *                                                                         *
 *   Created: Wed Jun 5 2002                                               *
 *                                                                         *
 *   Copyright (C) 2002-2005 by Kenneth Jennings                           *
 *   ken_jennings@bellsouth.net                                            *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CHECKING_2_HTML_INCL_
#define _CHECKING_2_HTML_INCL_

#include "csvData.h"

typedef struct _checking_
{
	char * date;
	char * description;
	char * withdrawals;
	char * deposits;
	char * balance;
} Checking;

typedef struct _checking_entry_
{
	struct _checking_entry_ * next;
	Checking                * txn;
} CheckingEntry;


Checking      * newChecking     (void);
CheckingEntry * newCheckingEntry(void);

bool destroyChecking     (Checking      * p);
bool destroyCheckingEntry(CheckingEntry * p);

/* char * strdup(char * s); */
/*int strcasecmp(char * s,
			   char * t); */
void strtolower(char * s);
void strtoupper(char * s);
void strtomixed(char * s);
void strtodeblank(char * s);

char * inttonbspstring(int val,
					   int len);
char * strtonbspstring(char * s,
					   int    len);
char * strpercentstring(int val,
						int denom);

char * hrefortext(char * s);

void debugChecking(void);

CheckingEntry * addChecking(Checking * p);

Checking * strtoChecking(char * date,
						 char * desc,
						 char * withdraw,
						 char * deposit,
						 char * balance);

int countMonthTxns(int month);

bool processChecking(CsvData ** fields);

CheckingEntry * gimmeCheckingList(void);

bool LoadCSVFile(FILE     * fp,
				 CsvData ** fieldSpecs,
				 bool    (* loadFunc)(CsvData ** ) );

bool LoadChecking(FILE * inputFile);

bool buildHTML(FILE          * out,
			   CheckingEntry * p,
			   char          * ltext);


int dumpUntilTag(FILE * infile,
				 FILE * outfile,
				 char * tag);
int dumpUntilEnd(FILE * infile,
				 FILE * outfile);


/* *** Things in MAIN *** */

typedef enum _hcolor
{
	HC_MIN        = 1,
	HC_TITLE_ROW  = 1,
	HC_ODD_MONTH  = 2,
	HC_EVEN_MONTH = 3,
	HC_ODD_ROW    = 4,
	HC_EVEN_ROW   = 5,
	HC_MAX        = 5
} HColor ;

/* getHColor() lives (badly) in main where it 
 * provides access to the color strings read as
 * command line parameters for the HTML 
 * generation code.
 */
char * getHColor(HColor n);

int doParms(int     argc,
			char ** argv);

void usage(void);


#endif

